<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
    integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.21/js/jquery.dataTables.min.js"
    integrity="sha512-BkpSL20WETFylMrcirBahHfSnY++H2O1W+UnEEO4yNIl+jI2+zowyoGJpbtk6bx97fBXf++WJHSSK2MV4ghPcg=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="gRoleTypeSelect" class="form-control btn-info">

          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-order" class="btn btn-success">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="role-table">
        <thead>
          <tr class="btn-primary">
            <th>STT</th>
            <th>Username</th>
            <th>First name</th>
            <th>Last name</th>
            <th>Email</th>
            <th>Age</th>
            <th>Role</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // Mảng gUserObjects là mảng chứa dữ liệu users
      var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
      ];
      // Mảng gRoleObjects là mảng chứa dữ liệu các roles
      var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin"
        },
        {
          roleId: 8,
          roleName: "Manager"
        },
        {
          roleId: 11,
          roleName: "Teacher"
        },
        {
          roleId: 13,
          roleName: "Staff"
        }
      ];
      const ARRAY_NAME_COL = ["id", "username", "firstname", "lastname", "age", "email", "roleId", "action"]
      const COL_ID = 0;
      const COL_USER_NAME = 1;
      const COL_FIRST_NAME = 2;
      const COL_LAST_NAME = 3;
      const COL_AGE = 5;
      const COL_EMAIL = 4;
      const COL_ROLEID = 6;
      const COL_ACTION = 7;

      var gSTT = 1;
      var vResultFilter = [];
      var vUserObj = {};
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoad();

      $("#btn-filter-order").on("click", function () {
        onBtnFilterClick();
      })
      $(document).on("click", '#dice-history', function () {
        alert("chuyển sang trang dice history");
        onBtnHistoryDiceClick(this);
      })
      $(document).on("click", '#voucher-history', function () {
        alert("chuyển sang trang voucher-history");
        onBtnHistoryVoucherClick(this);
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // hàm tải trang
      function onPageLoad() {
        $("#role-table").DataTable({
          data: gUserObjects,
          columns: [
            { data: ARRAY_NAME_COL[COL_ID] },
            { data: ARRAY_NAME_COL[COL_USER_NAME] },
            { data: ARRAY_NAME_COL[COL_FIRST_NAME] },
            { data: ARRAY_NAME_COL[COL_LAST_NAME] },
            { data: ARRAY_NAME_COL[COL_AGE] },
            { data: ARRAY_NAME_COL[COL_EMAIL] },
            { data: ARRAY_NAME_COL[COL_ROLEID] },
            { data: ARRAY_NAME_COL[COL_ACTION] },
          ],
          columnDefs: [
            {
              targets: COL_ID,
              render: function (data) {
                return gSTT++;
              }
            },
            {
              targets: COL_ACTION,
              defaultContent: `<i title="dice history" style="cursor:pointer; color:blue" class="fa-solid fa-dice" id="dice-history"></i> &nbsp;
        <i title="voucher history" style="cursor:pointer; color:blue" class="fa-solid fa-gift" id="voucher-history"></i>`
            }
          ]
        });
        // load du lieu vao o select
        loadDataToSelect(gRoleObjects);
        $("#role-table_info").html(`Có ${gUserObjects.length} bản ghi thõa mãn!`)

      }

      // hàm xử lí khi click nút lọc dữ liệu
      function onBtnFilterClick() {
        // Tạo đối tượng chứa đối tượng lọc
        var vFilter = {
          roleId: 0
        }
        // B1 thu thập dữ liệu lọc
        getData(vFilter);
        console.log(vFilter);
        // B2 kiểm tra 

        // B3 Lọc dữ liệu
        vResultFilter = filterData(vFilter);
        console.log(vResultFilter);
        // B4 hiển thị kết quả thu thập
        displayDataFilter(vResultFilter);
        $("#role-table_info").html(`Có ${vResultFilter.length} bản ghi thõa mãn!`)

      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm lấy dữ liệu fn, ln, username và xủ lý chuyển trang
      function onBtnHistoryDiceClick(paramDetailButton) {
        var vUserDataTable = $("#role-table").DataTable();
        var vHtmlTableRow = $(paramDetailButton).parents("tr");
        var vDataTableRow = vUserDataTable.row(vHtmlTableRow);
        var vUserObj = vDataTableRow.data();
        console.log(vUserObj)
        const vDETAIL_FORM_URL = "Task 43.40.html";
        var vUrlSiteToOpen = vDETAIL_FORM_URL +
          "?user_name=" + vUserObj.username +
          "&first_name=" + vUserObj.firstname +
          "&last_name=" + vUserObj.lastname;
        location.href = vUrlSiteToOpen;
      }
      function onBtnHistoryVoucherClick(paramDetailButton) {
        var vUserDataTable = $("#role-table").DataTable();
        var vHtmlTableRow = $(paramDetailButton).parents("tr");
        var vDataTableRow = vUserDataTable.row(vHtmlTableRow);
        var vUserObj = vDataTableRow.data();
        console.log(vUserObj)
        const vDETAIL_FORM_URL = "Task 43.70.html";
        var vUrlSiteToOpen = vDETAIL_FORM_URL +
          "?user_name=" + vUserObj.username +
          "&first_name=" + vUserObj.firstname +
          "&last_name=" + vUserObj.lastname;
        location.href = vUrlSiteToOpen;
      }
      // hàm hiển thị kết quả lọc được
      function displayDataFilter(paramResultFilter) {
        gSTT = 1;
        var vTable = $("#role-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramResultFilter);
        vTable.draw();
      }
      // haàm lọc dữ liệu
      function filterData(paramFilter) {
        var vResultFilter = [];
        vResultFilter = gUserObjects.filter(function (item) {
          return (item.roleId == paramFilter.roleId || paramFilter.roleId == 0);
        })
        return vResultFilter;
      }
      // hàm thu thập dữ liệu lọc
      function getData(paramFilter) {
        paramFilter.roleId = $("#gRoleTypeSelect").val();
      }
      // ham đẩy dữ liệu vào ô select
      function loadDataToSelect(paramRoleObjects) {
        $('#gRoleTypeSelect').append($('<option>', {
          value: 0,
          text: '--Chọn Role--'
        }));
        for (var bI = 0; bI < paramRoleObjects.length; bI++) {
          $('#gRoleTypeSelect').append($('<option>', {
            value: paramRoleObjects[bI].roleId,
            text: paramRoleObjects[bI].roleName
          }));
        }
      }
    </script>
</body>

</html>